<template>
	<div class="container offer-ride">
		<div class="row">
			<h2 class="pull-left"> Edit Open Ride </h2> 
			
	        <div class="pull-right">
				<router-link to="/" class="btn btn-primary" >Go Back</router-link>
			</div>
		</div>

		<flash-message transitionIn="animated swing" class="myCustomClass"></flash-message>

		 <div class="row">
		 	<div class="col-md-9">
			 	<h3>{{ ride['location_from'] }} &#8594; {{ ride['location_to'] }}
			 	</h3>
			 	<small>To change locations please create another Open Ride</small>
		 	</div>
		 	<div class="col-md-3">
				<span v-if="ride.active == true"> Active </span>
				<span v-else> Inactive </span> 
				<toggle-button v-model="ride.active" @change="changeStatus(ride.id)" />
			</div>

		 </div>
		 <div class="row">

		 	<div class="col-md-6">
				 <div class="form-with-label">
		            <span class="ride-label">Start Date:</span>
		            <div class="frm-ride ">
		                <datepicker  v-model="ride.open_date_from" id="dateFrom" placeholder="From Date " :disabled-dates="state.disabledDates"></datepicker>
		            </div>
		        </div>
		    </div>
		    <div class="col-md-6">
		        <div class="form-with-label ">
		            <span class="ride-label">End Date:</span>
		            <div class="frm-ride ">
		                <datepicker v-model="ride.open_date_to" id="dateFrom" placeholder="From Date " :disabled-dates="state.disabledDates"></datepicker>
		            </div>
		        </div>
	    	</div>
    	</div>
    	<div class="row">
	    	<div class="col-md-8">
		    	<div class="form-with-label">
		            <span class="ride-label">Times Available </span>
		            <div class="frm-ride ">
		                <multiselect v-model="hours" :multiple="true" deselect-label="Can't remove this value" track-by="time" label="time"placeholder="Select one" :options="options" :searchable="true" :allow-empty="false">
		                    <template slot="singleLabel" slot-scope="{ option }"><strong>{{ option.time }}</strong></template>
		                </multiselect>
		            </div>
		        </div>
		    </div>
		</div>
	    <div class="row">

	    	<div class="col-md-4">
			    <div class="form-with-label">
	                <span class="ride-label">Seats</span>
	                <div class="frm-ride">
	                    <integer-plusminus :min="1"
	                                       :max="5"
	                                       :step="1"
	                                       :vertical="false"
	                                       v-model="ride.seats">
	                        <p>Seats Available </p>
	                        {{ ride.seats }}

	                        <template slot="decrement">-</template>

	                        <template slot="increment">+</template>
	                    </integer-plusminus>

	                </div>
	            </div>
	        </div>
	        <div class="col-md-4">
	        	<div class="form-with-label">
	                <span class="ride-label">Price</span>
	                <div class="frm-ride">
	                    <integer-plusminus :min="0"
	                                       :max="ride.price + (ride.price*1.50)"
	                                       :step="1"
	                                       :vertical="false"
	                                       v-model="ride.price">
	                        <p>Driver Price:</p>
	                        {{ ride.price }}

	                        <template slot="decrement">-</template>

	                        <template slot="increment">+</template>
	                    </integer-plusminus>
	                </div>
	            </div>
	        </div> 
	        <div class="col-md-4">
	        	<div class="form-with-label">
	                <span class="ride-label">Luggage Amount</span>
	                <div class="frm-ride">
	                    <integer-plusminus :min="0"
	                                       :max="5"
	                                       :step="1"
	                                       :vertical="false"
	                                       v-model="ride.luggage_amount">
	                        <p>Number of Luggage Allowed</p>
	                        {{ ride.luggage_amount }}

	                        <template slot="decrement">-</template>

	                        <template slot="increment">+</template>
	                    </integer-plusminus>
	                </div>
	            </div>
	        </div>

        </div>

        <div class="row">
        	
        	<div class="col-md-6">
        		<div class="form-with-label">
	                <span class="ride-label">Luggage Size</span>
	                <div class="frm-ride">
	                    <select v-model="ride.luggage_size" class="form-control">
	                        <option value="Small">Small</option>
	                        <option value="Medium">Medium</option>
	                        <option value="Large">Large</option>
	                    </select>
	                </div>
	            </div>
        	</div> 
        </div> 
        <div class="row">
        	<div class="col-md-6">
        		<div class="form-with-label">
	                <span class="ride-label">Purpose of Ride</span>
	                <div class="frm-ride">
	                    <select v-model="ride.trip_purpose_id" class="form-control" >
	                        <option value="item.id" 
	                        v-for="item in purpose"
	                        v-bind:value="item.id"
	                        
	                        >{{item.type}}</option>
	                    </select>
	                </div>
	            </div>
        	</div>
        </div>
        <button class="btn btn-primary" v-on:click="updateRide"> Update Open Ride</button>
	</div>
</template>

<script>
	
	import Datepicker from 'vuejs-datepicker';
	import Multiselect from 'vue-multiselect'
    import {IntegerPlusminus} from 'vue-integer-plusminus';
    import axios from 'axios';
    import moment from 'moment';
    import { ToggleButton } from 'vue-js-toggle-button'

	export default {
		components:{Datepicker, IntegerPlusminus, Multiselect,ToggleButton},
    	name:"editopenride",
    	
    	mounted(){
    		this.getPurposes();
    		for(var i=0; i< this.ride.hours.length; i++){
    			var temp = {time:moment(String(this.ride.hours[i].hour), "h:mm:ss ").format('hh:mm a')};
    			this.hours.push(temp);
    		}
    		
    		window.scrollTo({top: 0, behavior: 'smooth'});
    	},
    	data(){
    		return{
    			ride : this.$route.params.ride,
    			message:'',
    			displayMessage:false,
    			hours:[],
    			state:{disabledDates: {
                        to: new Date(),
                    }
                },
                secondState:{
                    disabledDates:{
                        to: new Date(),
                    },
                },
                options:[
                    {time: '1:00 AM'}, {time: '2:00 AM'}, {time: '3:00 AM'}, {time: '4:00 AM'},
                    {time: '5:00 AM'}, {time: '6:00 AM'}, {time: '7:00 AM'}, {time: '8:00 AM'},
                    {time: '9:00 AM'}, {time: '10:00 AM'}, {time: '11:00 AM'}, {time: '12:00 AM'},
                    {time: '1:00 PM'}, {time: '2:00 PM'}, {time: '3:00 PM'}, {time: '4:00 PM'},
                    {time: '5:00 PM'}, {time: '6:00 PM'}, {time: '7:00 PM'}, {time: '8:00 PM'},
                    {time: '9:00 PM'}, {time: '10:00 PM'}, {time: '11:00 PM'}, {time: '12:00 PM'}
                ],
                purpose:[],
    		}
    	},
    	methods:{
    		getPurposes:function(){
                axios.get('/rides/fetchPurpose', {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    }
                }).then(response => {
                    this.purpose = response.data;
                }).catch(e => {
                    this.errors.push(e)
                })
            },
            updateRide:function(){
            	axios.post('/rides/open-rides/update/' +this.ride.id, {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                        'ride':this.ride,
                        'hours':this.hours
                    }
                }).then(response => {
                	this.flash(response.data['message'], response.data['status'],{timeout: 4500});
                	
                }).catch(e => {
                	console.log(e);
                    //this.errors.push(e)
                })
            },
            hideAlert:function(){
            	this.message = null;
            },
            changeStatus:function(id){
    			axios.post('/rides/openRide/status/' + id, {
                    body: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    }
                }).then(response => {

                	this.flash(response.data['message'], response.data['status'],{timeout: 3500});

                }).catch(e => {
                    console.log(e)
                })
    		},
    	},
    }
</script>